Index: .gitignore
===================================================================
--- .gitignore	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ .gitignore	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -4,4 +4,5 @@
 /doxygen/latex
 /tools/*.pyc
+/tools/__pycache__
 tags
 tools/sycek/
Index: abi/include/_bits/decls.h
===================================================================
--- abi/include/_bits/decls.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ abi/include/_bits/decls.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -61,4 +61,14 @@
 #endif  /* __cplusplus */
 
+/*
+ * __CONSTEXPR for headers shared by C and C++. Headers that are purely for
+ * C++ sources should use constexpr directly.
+ */
+#ifdef __cplusplus
+#define __CONSTEXPR constexpr
+#else
+#define __CONSTEXPR
+#endif
+
 #endif
 
Index: abi/include/_bits/uchar.h
===================================================================
--- abi/include/_bits/uchar.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ abi/include/_bits/uchar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -38,5 +38,12 @@
 #include <stdint.h>
 
+/*
+ * char8_t became part of C++ with C++20.
+ * It is part of C23 hence we define it for C compilations only.
+ */
+#ifndef __cplusplus
 typedef uint8_t char8_t;
+#endif
+
 typedef uint32_t char32_t;
 
Index: abi/include/abi/ipc/interfaces.h
===================================================================
--- abi/include/abi/ipc/interfaces.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ abi/include/abi/ipc/interfaces.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2014 Martin Decky
  * All rights reserved.
@@ -186,4 +187,8 @@
 	INTERFACE_DDEV =
 	    FOURCC_COMPACT('d', 'd', 'e', 'v') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_DISPCFG =
+	    FOURCC_COMPACT('d', 'c', 'f', 'g') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_DISPCFG_CB =
+	    FOURCC_COMPACT('d', 'c', 'f', 'g') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
 	INTERFACE_DISPLAY =
 	    FOURCC_COMPACT('d', 's', 'p', 'l') | IFACE_EXCHANGE_SERIALIZE,
@@ -192,4 +197,10 @@
 	INTERFACE_GC =
 	    FOURCC_COMPACT('g', 'f', 'x', 'c') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_WNDMGT =
+	    FOURCC_COMPACT('w', 'm', 'g', 't') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_WNDMGT_CB =
+	    FOURCC_COMPACT('w', 'm', 'g', 't') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_TBARCFG_NOTIFY =
+	    FOURCC_COMPACT('t', 'b', 'c', 'f') | IFACE_EXCHANGE_SERIALIZE
 } iface_t;
 
Index: abi/include/abi/proc/uarg.h
===================================================================
--- abi/include/abi/proc/uarg.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ abi/include/abi/proc/uarg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,5 +39,5 @@
 #include <_bits/native.h>
 
-typedef void (uspace_thread_function_t)(void *);
+typedef void uspace_thread_function_t(void *);
 
 /** Structure passed to uinit kernel thread as argument. */
Index: abi/include/abi/sysinfo.h
===================================================================
--- abi/include/abi/sysinfo.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ abi/include/abi/sysinfo.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,4 +37,5 @@
 #define _ABI_SYSINFO_H_
 
+#include <_bits/size_t.h>
 #include <stdbool.h>
 #include <abi/proc/task.h>
Index: boot/arch/arm32/_link.ld.in
===================================================================
--- boot/arch/arm32/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm32/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -7,6 +7,6 @@
 	.text : {
 		loader_start = .;
-		*(BOOTSTRAP);
-		*(.text);
+		KEEP(*(BOOTSTRAP));
+		*(.text .text.*);
 	}
 	. = BOOT_BASE + 0x8000;
@@ -14,16 +14,14 @@
 		*(BOOTPT);      /* bootstrap page table */
 		*(BOOTSTACK);   /* bootstrap stack */
-		*(.data);       /* initialized data */
-		*(.rodata);
-		*(.rodata.*);
-		*(.sdata);
-		*(.reginfo);
-		*(.sbss);
-		*(.scommon);
-		*(.bss);        /* uninitialized static variables */
+		*(.data .data.*);       /* initialized data */
+		*(.rodata .rodata.*);
+		*(.sdata .sdata.*);
+		*(.sbss .sbss.*);
+		*(.scommon .scommon.*);
+		*(.bss .bss.*);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
 		loader_end = .;
 		payload_start = .;
-		*(.payload);
+		KEEP(*(.payload));
 		payload_end = .;
 	}
Index: boot/arch/arm32/meson.build
===================================================================
--- boot/arch/arm32/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm32/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -65,10 +65,10 @@
 	'src/mm.c',
 	'src/putchar.c',
+	'../../../common/stdc/mem.c',
 	'../../genarch/src/division.c',
-	'../../generic/src/memstr.c',
 	'../../generic/src/printf_core.c',
 	'../../generic/src/vprintf.c',
 	'../../generic/src/printf.c',
-	'../../generic/src/str.c',
+	'../../../common/str.c',
 	'../../generic/src/version.c',
 	'../../generic/src/inflate.c',
Index: boot/arch/arm32/src/main.c
===================================================================
--- boot/arch/arm32/src/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm32/src/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -40,5 +40,5 @@
 #include <halt.h>
 #include <printf.h>
-#include <memstr.h>
+#include <mem.h>
 #include <version.h>
 #include <macros.h>
Index: boot/arch/arm64/_link.ld.in
===================================================================
--- boot/arch/arm64/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm64/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -7,6 +7,6 @@
 	.text : {
 		HIDDEN(loader_start = .);
-		*(BOOTSTRAP);
-		*(.text);
+		KEEP(*(BOOTSTRAP));
+		*(.text .text.*);
 	}
 	.dynamic : { *(.dynamic); }
@@ -17,12 +17,12 @@
 	. = 0x8000;
 	.data : {
-		*(.data*);      /* initialized data */
-		*(.rodata*);
-		*(.bss);        /* uninitialized static variables */
+		*(.data .data.*);      /* initialized data */
+		*(.rodata .rodata.*);
+		*(.bss .bss.*);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
-		*(.got .got.plt);
+		*(.got .got.*);
 		HIDDEN(loader_end = .);
 		HIDDEN(payload_start = .);
-		*(.payload);
+		KEEP(*(.payload));
 		HIDDEN(payload_end = .);
 	}
Index: boot/arch/arm64/meson.build
===================================================================
--- boot/arch/arm64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm64/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -48,13 +48,13 @@
 	'src/main.c',
 	'src/relocate.c',
+	'../../../common/stdc/mem.c',
 	'../../genarch/src/efi.c',
 	'../../generic/src/gzip.c',
 	'../../generic/src/inflate.c',
 	'../../generic/src/kernel.c',
-	'../../generic/src/memstr.c',
 	'../../generic/src/payload.c',
 	'../../generic/src/printf.c',
 	'../../generic/src/printf_core.c',
-	'../../generic/src/str.c',
+	'../../../common/str.c',
 	'../../generic/src/tar.c',
 	'../../generic/src/version.c',
Index: boot/arch/arm64/src/main.c
===================================================================
--- boot/arch/arm64/src/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm64/src/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -46,5 +46,5 @@
 #include <kernel.h>
 #include <macros.h>
-#include <memstr.h>
+#include <mem.h>
 #include <payload.h>
 #include <printf.h>
Index: boot/arch/ia64/_link.ld.in
===================================================================
--- boot/arch/ia64/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/ia64/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -5,20 +5,18 @@
 	.boot 0x4400000: AT (0x4400000) {
 		loader_start = .;
-		*(BOOTSTRAP);
-		*(.text);
-		*(.text.*);
-		*(.sdata);
-		*(.sdata2);
-		*(.sbss);
-		*(.rodata);
-		*(.rodata.*);
+		KEEP(*(BOOTSTRAP));
+		*(.text .text.*);
+		*(.sdata .sdata.*);
+		*(.sdata2 .sdata2.*);
+		*(.sbss .sbss.*);
+		*(.rodata .rodata.*);
 		*(.data .data.*);       /* initialized data */
 		__gp = . ;
 		*(.got .got.*);
-		*(.bss);                /* uninitialized static variables */
+		*(.bss .bss.*);                /* uninitialized static variables */
 		*(COMMON);
 		loader_end = .;
 		payload_start = .;
-		*(.payload);
+		KEEP(*(.payload));
 		payload_end = .;
 	}
Index: boot/arch/ia64/meson.build
===================================================================
--- boot/arch/ia64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/ia64/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -41,12 +41,12 @@
 	'src/pal_asm.S',
 	'src/putchar.c',
+	'../../../common/stdc/mem.c',
 	'../../genarch/src/efi.c',
 	'../../genarch/src/division.c',
 	'../../generic/src/balloc.c',
-	'../../generic/src/memstr.c',
 	'../../generic/src/printf_core.c',
 	'../../generic/src/vprintf.c',
 	'../../generic/src/printf.c',
-	'../../generic/src/str.c',
+	'../../../common/str.c',
 	'../../generic/src/version.c',
 	'../../generic/src/inflate.c',
Index: boot/arch/ia64/src/main.c
===================================================================
--- boot/arch/ia64/src/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/ia64/src/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,5 +37,5 @@
 #include <halt.h>
 #include <printf.h>
-#include <memstr.h>
+#include <mem.h>
 #include <version.h>
 #include <macros.h>
Index: boot/arch/mips32/_link.ld.in
===================================================================
--- boot/arch/mips32/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/mips32/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -9,20 +9,19 @@
 	.text : {
 		loader_start = .;
-		*(BOOTSTRAP);
-		*(.text);
+		KEEP(*(BOOTSTRAP));
+		*(.text .text.*);
 	}
 	.data : {
-		*(.data);       /* initialized data */
-		*(.rodata);
-		*(.rodata.*);
-		*(.sdata);
+		*(.data .data.*);       /* initialized data */
+		*(.rodata .rodata.*);
+		*(.sdata .sdata.*);
 		*(.reginfo);
-		*(.sbss);
-		*(.scommon);
-		*(.bss);        /* uninitialized static variables */
+		*(.sbss .sbss.*);
+		*(.scommon .scommon.*);
+		*(.bss .bss.*);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
 		loader_end = .;
 		payload_start = .;
-		*(.payload);
+		KEEP(*(.payload));
 		payload_end = .;
 	}
Index: boot/arch/mips32/meson.build
===================================================================
--- boot/arch/mips32/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/mips32/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -42,11 +42,11 @@
 	'src/main.c',
 	'src/putchar.c',
+	'../../../common/stdc/mem.c',
 	'../../genarch/src/division.c',
 	'../../genarch/src/multiplication.c',
-	'../../generic/src/memstr.c',
 	'../../generic/src/printf_core.c',
 	'../../generic/src/vprintf.c',
 	'../../generic/src/printf.c',
-	'../../generic/src/str.c',
+	'../../../common/str.c',
 	'../../generic/src/version.c',
 	'../../generic/src/inflate.c',
Index: boot/arch/mips32/src/main.c
===================================================================
--- boot/arch/mips32/src/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/mips32/src/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -33,5 +33,5 @@
 #include <halt.h>
 #include <printf.h>
-#include <memstr.h>
+#include <mem.h>
 #include <version.h>
 #include <macros.h>
Index: boot/arch/ppc32/_link.ld.in
===================================================================
--- boot/arch/ppc32/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/ppc32/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -5,21 +5,18 @@
 	.text : {
 		loader_start = .;
-		*(BOOTSTRAP);
-		*(.text);
-		*(.text.*);
+		KEEP(*(BOOTSTRAP));
+		*(.text .text.*);
 	}
 	.data : {
-		*(.data);       /* initialized data */
-		*(.rodata);
-		*(.rodata.*);
-		*(.sdata);
-		*(.reginfo);
-		*(.sbss);
-		*(.scommon);
-		*(.bss);        /* uninitialized static variables */
+		*(.data .data.*);       /* initialized data */
+		*(.rodata .rodata.*);
+		*(.sdata .sdata.*);
+		*(.sbss .sbss.*);
+		*(.scommon .scommon.*);
+		*(.bss .bss.*);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
 		loader_end = .;
 		payload_start = .;
-		*(.payload);
+		KEEP(*(.payload));
 		payload_end = .;
 	}
Index: boot/arch/ppc32/meson.build
===================================================================
--- boot/arch/ppc32/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/ppc32/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,4 +37,5 @@
 	'src/ofw.c',
 
+	'../../../common/stdc/mem.c',
 	'../../genarch/src/ofw.c',
 	'../../genarch/src/ofw_tree.c',
@@ -42,9 +43,8 @@
 	'../../genarch/src/multiplication.c',
 	'../../generic/src/balloc.c',
-	'../../generic/src/memstr.c',
 	'../../generic/src/printf_core.c',
 	'../../generic/src/vprintf.c',
 	'../../generic/src/printf.c',
-	'../../generic/src/str.c',
+	'../../../common/str.c',
 	'../../generic/src/version.c',
 	'../../generic/src/inflate.c',
Index: boot/arch/ppc32/src/main.c
===================================================================
--- boot/arch/ppc32/src/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/ppc32/src/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -35,5 +35,5 @@
 #include <halt.h>
 #include <printf.h>
-#include <memstr.h>
+#include <mem.h>
 #include <version.h>
 #include <macros.h>
Index: boot/arch/riscv64/_link.ld.in
===================================================================
--- boot/arch/riscv64/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/riscv64/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -8,6 +8,6 @@
 	.text : {
 		loader_start = .;
-		*(BOOTSTRAP);
-		*(.text);
+		KEEP(*(BOOTSTRAP));
+		*(.text .text.*);
 	}
 
@@ -27,16 +27,14 @@
 
 	.data : {
-		*(.data);       /* initialized data */
-		*(.rodata);
-		*(.rodata.*);
-		*(.sdata);
-		*(.reginfo);
-		*(.sbss);
-		*(.scommon);
-		*(.bss);        /* uninitialized static variables */
+		*(.data .data.*);       /* initialized data */
+		*(.rodata .rodata.*);
+		*(.sdata .sdata.*);
+		*(.sbss .sbss.*);
+		*(.scommon .scommon.*);
+		*(.bss .bss.*);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
 		loader_end = .;
 		payload_start = .;
-		*(.payload);
+		KEEP(*(.payload));
 		payload_end = .;
 	}
Index: boot/arch/riscv64/meson.build
===================================================================
--- boot/arch/riscv64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/riscv64/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,9 +37,10 @@
 	'src/ucb.c',
 	'src/putchar.c',
-	'../../generic/src/memstr.c',
+
+	'../../../common/stdc/mem.c',
 	'../../generic/src/printf_core.c',
 	'../../generic/src/vprintf.c',
 	'../../generic/src/printf.c',
-	'../../generic/src/str.c',
+	'../../../common/str.c',
 	'../../generic/src/version.c',
 	'../../generic/src/inflate.c',
Index: boot/arch/sparc64/_link.ld.in
===================================================================
--- boot/arch/sparc64/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/sparc64/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -5,18 +5,16 @@
 	.boot : {
 		loader_start = .;
-		*(BOOTSTRAP);
-		*(.text.*);
+		KEEP(*(BOOTSTRAP));
+		*(.text .text.*);
 
-		*(.data);       /* initialized data */
-		*(.rodata);
-		*(.rodata.*);
-		*(.sdata);
-		*(.reginfo);
-		*(.sbss);
-		*(.bss);        /* uninitialized static variables */
+		*(.data .data.*);       /* initialized data */
+		*(.rodata .rodata.*);
+		*(.sdata .sdata.*);
+		*(.sbss .sbss.*);
+		*(.bss .bss.*);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
 		loader_end = .;
 		payload_start = .;
-		*(.payload);
+		KEEP(*(.payload));
 		payload_end = .;
 	}
Index: boot/arch/sparc64/meson.build
===================================================================
--- boot/arch/sparc64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/sparc64/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,12 +37,12 @@
 	'src/ofw.c',
 
+	'../../../common/stdc/mem.c',
 	'../../genarch/src/ofw.c',
 	'../../genarch/src/ofw_tree.c',
 	'../../generic/src/balloc.c',
-	'../../generic/src/memstr.c',
 	'../../generic/src/printf_core.c',
 	'../../generic/src/vprintf.c',
 	'../../generic/src/printf.c',
-	'../../generic/src/str.c',
+	'../../../common/str.c',
 	'../../generic/src/version.c',
 	'../../generic/src/inflate.c',
Index: boot/arch/sparc64/src/main.c
===================================================================
--- boot/arch/sparc64/src/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/sparc64/src/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,5 +36,5 @@
 #include <halt.h>
 #include <printf.h>
-#include <memstr.h>
+#include <mem.h>
 #include <version.h>
 #include <macros.h>
Index: boot/genarch/src/ofw_tree.c
===================================================================
--- boot/genarch/src/ofw_tree.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/genarch/src/ofw_tree.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -33,5 +33,5 @@
 #include <str.h>
 #include <balloc.h>
-#include <memstr.h>
+#include <mem.h>
 
 static char path[OFW_TREE_PATH_MAX_LEN + 1];
Index: boot/generic/include/assert.h
===================================================================
--- boot/generic/include/assert.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ boot/generic/include/assert.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,34 @@
+/*
+ * Copyright (c) 2023 Jiří Zárevúcky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef BOOT_ASSERT_H_
+#define BOOT_ASSERT_H_
+
+#define assert(expr) ((void) (expr))
+
+#endif /* BOOT_ASSERT_H_ */
Index: boot/generic/include/errno.h
===================================================================
--- boot/generic/include/errno.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/generic/include/errno.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,4 +39,5 @@
 #define EINVAL     -14  /* Invalid value. */
 #define EOVERFLOW  -16  /* The result does not fit its size. */
+#define EIO        -17
 
 typedef int errno_t;
Index: boot/generic/src/gzip.c
===================================================================
--- boot/generic/src/gzip.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/generic/src/gzip.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -32,5 +32,5 @@
 #include <stddef.h>
 #include <errno.h>
-#include <memstr.h>
+#include <mem.h>
 #include <byteorder.h>
 #include <gzip.h>
Index: boot/generic/src/inflate.c
===================================================================
--- boot/generic/src/inflate.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/generic/src/inflate.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -69,5 +69,5 @@
 #include <stdint.h>
 #include <errno.h>
-#include <memstr.h>
+#include <mem.h>
 #include <inflate.h>
 
Index: boot/generic/src/payload.c
===================================================================
--- boot/generic/src/payload.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/generic/src/payload.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,5 +36,5 @@
 #include <gzip.h>
 #include <stdbool.h>
-#include <memstr.h>
+#include <mem.h>
 #include <errno.h>
 #include <str.h>
Index: boot/meson.build
===================================================================
--- boot/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -78,4 +78,5 @@
 		'../abi/arch'/BARCH/'include',
 		'../abi/include',
+		'../common/include',
 	)
 
@@ -98,5 +99,4 @@
 		'-Wl,--nmagic',
 		'-T', meson.current_build_dir()/'_link.ld',
-		'-Wl,--no-gc-sections',
 	]
 
Index: common/adt/bitmap.c
===================================================================
--- common/adt/bitmap.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ common/adt/bitmap.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,338 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kernel_generic_adt
+ * @{
+ */
+/**
+ * @file
+ * @brief Implementation of bitmap ADT.
+ *
+ * This file implements bitmap ADT and provides functions for
+ * setting and clearing ranges of bits and for finding ranges
+ * of unset bits.
+ */
+
+#include <adt/bitmap.h>
+#include <align.h>
+#include <assert.h>
+#include <macros.h>
+#include <typedefs.h>
+
+#define ALL_ONES    0xff
+#define ALL_ZEROES  0x00
+
+/** Unchecked version of bitmap_get()
+ *
+ * This version of bitmap_get() does not do any boundary checks.
+ *
+ * @param bitmap  Bitmap to access.
+ * @param element Element to access.
+ *
+ * @return Bit value of the element in the bitmap.
+ *
+ */
+static unsigned int bitmap_get_fast(bitmap_t *bitmap, size_t element)
+{
+	size_t byte = element / BITMAP_ELEMENT;
+	uint8_t mask = 1 << (element & BITMAP_REMAINER);
+
+	return !!((bitmap->bits)[byte] & mask);
+}
+
+/** Get bitmap size
+ *
+ * Return the size (in bytes) required for the bitmap.
+ *
+ * @param elements   Number bits stored in bitmap.
+ *
+ * @return Size (in bytes) required for the bitmap.
+ *
+ */
+size_t bitmap_size(size_t elements)
+{
+	size_t size = elements / BITMAP_ELEMENT;
+
+	if ((elements % BITMAP_ELEMENT) != 0)
+		size++;
+
+	return size;
+}
+
+/** Initialize bitmap.
+ *
+ * No portion of the bitmap is set or cleared by this function.
+ *
+ * @param bitmap     Bitmap structure.
+ * @param elements   Number of bits stored in bitmap.
+ * @param data       Address of the memory used to hold the map.
+ *                   The optional 2nd level bitmap follows the 1st
+ *                   level bitmap.
+ *
+ */
+void bitmap_initialize(bitmap_t *bitmap, size_t elements, void *data)
+{
+	bitmap->elements = elements;
+	bitmap->bits = (uint8_t *) data;
+	bitmap->next_fit = 0;
+}
+
+/** Set range of bits.
+ *
+ * @param bitmap Bitmap structure.
+ * @param start  Starting bit.
+ * @param count  Number of bits to set.
+ *
+ */
+void bitmap_set_range(bitmap_t *bitmap, size_t start, size_t count)
+{
+	assert(start + count <= bitmap->elements);
+
+	if (count == 0)
+		return;
+
+	size_t start_byte = start / BITMAP_ELEMENT;
+	size_t aligned_start = ALIGN_UP(start, BITMAP_ELEMENT);
+
+	/* Leading unaligned bits */
+	size_t lub = min(aligned_start - start, count);
+
+	/* Aligned middle bits */
+	size_t amb = (count > lub) ? (count - lub) : 0;
+
+	/* Trailing aligned bits */
+	size_t tab = amb % BITMAP_ELEMENT;
+
+	if (start + count < aligned_start) {
+		/* Set bits in the middle of byte. */
+		bitmap->bits[start_byte] |=
+		    ((1 << lub) - 1) << (start & BITMAP_REMAINER);
+		return;
+	}
+
+	if (lub) {
+		/* Make sure to set any leading unaligned bits. */
+		bitmap->bits[start_byte] |=
+		    ~((1 << (BITMAP_ELEMENT - lub)) - 1);
+	}
+
+	size_t i;
+
+	for (i = 0; i < amb / BITMAP_ELEMENT; i++) {
+		/* The middle bits can be set byte by byte. */
+		bitmap->bits[aligned_start / BITMAP_ELEMENT + i] =
+		    ALL_ONES;
+	}
+
+	if (tab) {
+		/* Make sure to set any trailing aligned bits. */
+		bitmap->bits[aligned_start / BITMAP_ELEMENT + i] |=
+		    (1 << tab) - 1;
+	}
+}
+
+/** Clear range of bits.
+ *
+ * @param bitmap Bitmap structure.
+ * @param start  Starting bit.
+ * @param count  Number of bits to clear.
+ *
+ */
+void bitmap_clear_range(bitmap_t *bitmap, size_t start, size_t count)
+{
+	assert(start + count <= bitmap->elements);
+
+	if (count == 0)
+		return;
+
+	size_t start_byte = start / BITMAP_ELEMENT;
+	size_t aligned_start = ALIGN_UP(start, BITMAP_ELEMENT);
+
+	/* Leading unaligned bits */
+	size_t lub = min(aligned_start - start, count);
+
+	/* Aligned middle bits */
+	size_t amb = (count > lub) ? (count - lub) : 0;
+
+	/* Trailing aligned bits */
+	size_t tab = amb % BITMAP_ELEMENT;
+
+	if (start + count < aligned_start) {
+		/* Set bits in the middle of byte */
+		bitmap->bits[start_byte] &=
+		    ~(((1 << lub) - 1) << (start & BITMAP_REMAINER));
+		return;
+	}
+
+	if (lub) {
+		/* Make sure to clear any leading unaligned bits. */
+		bitmap->bits[start_byte] &=
+		    (1 << (BITMAP_ELEMENT - lub)) - 1;
+	}
+
+	size_t i;
+
+	for (i = 0; i < amb / BITMAP_ELEMENT; i++) {
+		/* The middle bits can be cleared byte by byte. */
+		bitmap->bits[aligned_start / BITMAP_ELEMENT + i] =
+		    ALL_ZEROES;
+	}
+
+	if (tab) {
+		/* Make sure to clear any trailing aligned bits. */
+		bitmap->bits[aligned_start / BITMAP_ELEMENT + i] &=
+		    ~((1 << tab) - 1);
+	}
+
+	bitmap->next_fit = start_byte;
+}
+
+/** Copy portion of one bitmap into another bitmap.
+ *
+ * @param dst   Destination bitmap.
+ * @param src   Source bitmap.
+ * @param count Number of bits to copy.
+ *
+ */
+void bitmap_copy(bitmap_t *dst, bitmap_t *src, size_t count)
+{
+	assert(count <= dst->elements);
+	assert(count <= src->elements);
+
+	size_t i;
+
+	for (i = 0; i < count / BITMAP_ELEMENT; i++)
+		dst->bits[i] = src->bits[i];
+
+	if (count % BITMAP_ELEMENT) {
+		bitmap_clear_range(dst, i * BITMAP_ELEMENT,
+		    count % BITMAP_ELEMENT);
+		dst->bits[i] |= src->bits[i] &
+		    ((1 << (count % BITMAP_ELEMENT)) - 1);
+	}
+}
+
+static int constraint_satisfy(size_t index, size_t base, size_t constraint)
+{
+	return (((base + index) & constraint) == 0);
+}
+
+/** Find a continuous zero bit range
+ *
+ * Find a continuous zero bit range in the bitmap. The address
+ * computed as the sum of the index of the first zero bit and
+ * the base argument needs to be compliant with the constraint
+ * (those bits that are set in the constraint cannot be set in
+ * the address).
+ *
+ * If the index argument is non-NULL, the continuous zero range
+ * is set and the index of the first bit is stored to index.
+ * Otherwise the bitmap stays untouched.
+ *
+ * @param bitmap     Bitmap structure.
+ * @param count      Number of continuous zero bits to find.
+ * @param base       Address of the first bit in the bitmap.
+ * @param prefered   Prefered address to start searching from.
+ * @param constraint Constraint for the address of the first zero bit.
+ * @param index      Place to store the index of the first zero
+ *                   bit. Can be NULL (in which case the bitmap
+ *                   is not modified).
+ *
+ * @return Non-zero if a continuous range of zero bits satisfying
+ *         the constraint has been found.
+ * @return Zero otherwise.
+ *
+ */
+bool bitmap_allocate_range(bitmap_t *bitmap, size_t count, size_t base,
+    size_t prefered, size_t constraint, size_t *index)
+{
+	if (count == 0)
+		return false;
+
+	size_t size = bitmap_size(bitmap->elements);
+	size_t next_fit = bitmap->next_fit;
+
+	/*
+	 * Adjust the next-fit value according to the address
+	 * the caller prefers to start the search at.
+	 */
+	if ((prefered > base) && (prefered < base + bitmap->elements)) {
+		size_t prefered_fit = (prefered - base) / BITMAP_ELEMENT;
+
+		if (prefered_fit > next_fit)
+			next_fit = prefered_fit;
+	}
+
+	for (size_t pos = 0; pos < size; pos++) {
+		size_t byte = (next_fit + pos) % size;
+
+		/* Skip if the current byte has all bits set */
+		if (bitmap->bits[byte] == ALL_ONES)
+			continue;
+
+		size_t byte_bit = byte * BITMAP_ELEMENT;
+
+		for (size_t bit = 0; bit < BITMAP_ELEMENT; bit++) {
+			size_t i = byte_bit + bit;
+
+			if (i >= bitmap->elements)
+				break;
+
+			if (!constraint_satisfy(i, base, constraint))
+				continue;
+
+			if (!bitmap_get_fast(bitmap, i)) {
+				size_t continuous = 1;
+
+				for (size_t j = 1; j < count; j++) {
+					if ((i + j < bitmap->elements) &&
+					    (!bitmap_get_fast(bitmap, i + j)))
+						continuous++;
+					else
+						break;
+				}
+
+				if (continuous == count) {
+					if (index != NULL) {
+						bitmap_set_range(bitmap, i, count);
+						bitmap->next_fit = i / BITMAP_ELEMENT;
+						*index = i;
+					}
+
+					return true;
+				} else
+					i += continuous;
+			}
+		}
+	}
+
+	return false;
+}
+
+/** @}
+ */
